#include "stdafx.h"
#include <stdlib.h>
#include <windows.h> 

#define TAMANHO_MAPA 20  //Tamanho maximo do mapa

struct Posicao2D{        //Estrutura para armazenar a posicao 2D do robo e destino
	int x;
	int y;
};

Posicao2D Robo;          //Posicao do robo no mapa
Posicao2D Destino;       //Variavel para armazenar o destino do robo

/*Mapa do mundo. A letra X representa uma parede e o espao em branco representa
um local vaziu onde o robo pode andar. O robo no pode passar pelas paredes.*/
char Mapa[TAMANHO_MAPA][TAMANHO_MAPA] = 
{{'X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X'},
 {'X',' ','X',' ',' ',' ',' ','X',' ',' ',' ',' ',' ',' ',' ','X','X',' ',' ','X'},
 {'X',' ','X',' ',' ',' ',' ','X',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','X'},
 {'X',' ','X','X','X',' ',' ','X',' ',' ','X','X','X',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ',' ','X',' ',' ','X','X','X','X',' ','X',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ',' ','X',' ',' ','X',' ',' ',' ',' ','X','X','X','X',' ','X',' ','X'},
 {'X','X','X',' ','X','X',' ','X',' ',' ',' ',' ','X',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ',' ',' ',' ',' ',' ',' ','X','X','X','X',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ',' ','X','X','X',' ',' ',' ',' ',' ',' ',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ',' ','X',' ','X',' ','X','X','X','X','X','X',' ','X','X','X',' ','X'},
 {'X',' ',' ',' ','X',' ','X',' ',' ',' ',' ',' ',' ','X',' ',' ',' ',' ',' ','X'},
 {'X',' ',' ',' ','X',' ',' ',' ',' ',' ',' ',' ',' ','X',' ',' ',' ',' ',' ','X'},
 {'X','X','X','X','X',' ','X','X','X','X','X',' ',' ','X',' ','X','X','X','X','X'},
 {'X',' ',' ',' ',' ',' ','X',' ',' ',' ','X',' ',' ','X',' ','X',' ',' ',' ','X'},
 {'X',' ',' ',' ',' ',' ','X',' ','X',' ','X',' ',' ','X',' ','X',' ',' ',' ','X'},
 {'X','X',' ','X','X','X','X',' ','X',' ','X',' ','X','X',' ','X',' ','X',' ','X'},
 {'X',' ',' ','X',' ',' ',' ',' ','X','X','X',' ','X',' ',' ','X',' ','X',' ','X'},
 {'X',' ',' ','X',' ','X','X',' ',' ',' ',' ',' ','X','X','X','X',' ','X',' ','X'},
 {'X',' ',' ','X',' ',' ',' ',' ','X','X','X',' ',' ',' ',' ',' ',' ','X',' ','X'},
 {'X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X','X'}};

/*Funcao para mover o robo para cima uma vez*/
void MoverParaCima()
{
	if (Robo.y > 0)
		Robo.y--;
}

/*Funcao para mover o robo para baixo uma vez*/
void MoverParaBaixo()
{
	if (Robo.y < TAMANHO_MAPA)
		Robo.y++;
}

/*Funcao para mover o robo para direita uma vez*/
void MoverParaDireita()
{
	if (Robo.x < TAMANHO_MAPA)
		Robo.x++;
}

/*Funcao para mover o robo para esquerda uma vez*/
void MoverParaEsquerda()
{
	if (Robo.x > 0)
		Robo.x--;
}

/*Funcao para desenhar o mapa e robo na sua devida posicao*/
void DesenhaMap()
{
	for (int y = 0; y < TAMANHO_MAPA; y++)
	{
		for (int x = 0; x < TAMANHO_MAPA; x++)
		{	
			if ((x == Robo.x)&&(y == Robo.y))
				printf("@");
			else
				printf("%c", Mapa[x][y]);
		}
		printf("\n");
	}
	printf("\n");
}

/*Funcao para atualizar a posicao do robo e faze-lo andar*/
void AtualizaPosicaoRobo()
{
	////////AS PROXIMAS LINHAS DE CODIGO SAO APENAS PARA ILUSTRAR///////
	////////A MOVIMENTACAO DO ROBO, ELAS DEVEM SER REMOVIDAS.     //////	
	if (Robo.x < Destino.x)
		MoverParaDireita();
	if (Robo.x > Destino.x)
		MoverParaEsquerda();

	if (Robo.y < Destino.y)
		MoverParaBaixo();
	if (Robo.y > Destino.y)
		MoverParaCima();
	/////////////////////////////////////////////////////////////////////
}

/*Funcao principal*/
int main(int argc, _TCHAR* argv[])
{		
	Robo.x = 9; //Define a posicao inicial do robo
	Robo.y = 2;

	Destino.x = Robo.x; //Define o destino do robo como sendo a sua prosiao inicial
	Destino.y = Robo.y;	

	while (true)
	{
		DesenhaMap(); //Desenha o mapa
		
		if ((Robo.x == Destino.x)&&(Robo.y == Destino.y)) //Se o robo esta no seu destino solicita um novo destino
		{
			printf("Digite a coordenada de destino X: ");
			scanf("%d", &Destino.x);
			printf("Digite a coordenada de destino Y: ");
			scanf("%d", &Destino.y);
		}
		
		Sleep(100); //Um pequeno intervalo para podermos visualizar a movimentacao do robo

		AtualizaPosicaoRobo();

		system("cls"); //Limpa a tela
	}
	return 0;
}

